// this code is programed auto by resource editor.
// TemplateType:_TEMPLATETYPE_
#include "_APPNAME_Dialog_DIALOGNAME_.h"


#define debugs  { cout << __FILE__ << ':' << __LINE__ << ':' << __FUNCTION__ << endl; }

//--------------------------------------------------------------------------------------
// コンストラクタ
_APPNAME_Dialog_DIALOGNAME_::_APPNAME_Dialog_DIALOGNAME_()
{
	debugs;
}

//--------------------------------------------------------------------------------------
// デストラクタ
_APPNAME_Dialog_DIALOGNAME_::~_APPNAME_Dialog_DIALOGNAME_()
{
	debugs;
}



//--------------------------------------------------------------------------------------
// 初期化処理
void _APPNAME_Dialog_DIALOGNAME_::OnInit()
{
	debugs;
	// セッションが確立し、ダイアログが新規に作成されたときに呼ばれます。
	// ダイアログ生成時に１度だけ行う初期化処理を行って下さい。

	// リソース情報をロードしておくと、端末からCONDITION命令が来たときに
	// 変更内容を更新させることが出来ます。
	// また、必要に応じ外部の情報を収集し同期しておきます
	
	// 共有エリアにリソース情報をロードする（不要であればロードしなくても可）
	LoadJsonShare();

	ResourceToDevice(); // 反映

	// タイマーを使用する場合のサンプルコード
//	SetTimerInterval(5000,123);
}

//--------------------------------------------------------------------------------------
// ダイアログ遷移前通知
// pgsock 通信ソケット
// jo     JSONコマンドオブジェクト
void _APPNAME_Dialog_DIALOGNAME_::OnChangeBefore( PGClientSocket *pgsock, PGJsonCommand *jo )
{
	debugs;
	// 端末がダイアログを遷移する直前に呼ばれます（遷移する前の現在のダイアログが受け取る通知）
}

//--------------------------------------------------------------------------------------
// ダイアログ遷移通知
// pgsock 通信ソケット
// jo     JSONコマンドオブジェクト
void _APPNAME_Dialog_DIALOGNAME_::OnChange( PGClientSocket *pgsock, PGJsonCommand *jo )
{
	debugs;
	// 端末がダイアログを遷移した直後に呼ばれます。（表示された新しいダイアログが受け取る通知）
	// 端末はダイアログの内容が初期値のままの状態です。
	// 共有エリアで保持している内容を対象の全端末へ送信（更新）する必要があります。

	// 同じダイアログを開いている自分を含む全ユーザにUPDATEを送信
	// 全てのオブジェクト、全ての要素を送信します。
	SendUpdateShare(true);
}

//--------------------------------------------------------------------------------------
// 状態変更通知
// pgsock 通信ソケット
// jo     JSONコマンドオブジェクト
void _APPNAME_Dialog_DIALOGNAME_::OnCondition( PGClientSocket *pgsock, PGJsonCommand *jo )
{
	debugs;
	// クリックやタイマーなど予め登録したトリガで、端末の状態がCONDITIONコマンドで
	// 送信されてきた時によばれます。

	// 受信したCONDITIONコマンドに含まれる全てのオブジェクトの内容を共有エリアへ保存します
	// この関数コールにより OnUpdate がコールバックされます。
	UpdateResourceShare( jo, pgsock->GetSessionId() );

	// 物理デバイスに反映
	ResourceToDevice();
}
//--------------------------------------------------------------------------------------
// 各オブジェクトの状態変更通知（更新オブジェクトの数だけ繰り返し呼ばれます）
// to     JSONコマンドオブジェクト
// from   JSONコマンドオブジェクト
void _APPNAME_Dialog_DIALOGNAME_::OnUpdate(PGJsonObject* to ,PGJsonObject* from ,const SGString sessionid)
{
	// 基本クラス内で更新処理が行われ、受信した更新内容をリソース内へ取り込みます。
	PGDialog::OnUpdate(to,from,sessionid);
}

//--------------------------------------------------------------------------------------
// 端末が CONDITION コマンドを送信するトリガになったオブジェクトのコールバック通知関数
// pgsock     受信ソケット
// jobj       トリガとなったオブジェクト（Json）
// actiontype トリガとなった要因
//            ・Clicked       オブジェクトがクリックされた
//            ・ItemClicked   GRIDで表示された項目がクリックされた
//            ・ItemSelected  PULLDOWNで表示された項目が選択された
//            ・SlideTouched  SLIDEBARのつまみが押下された（ドラッグ開始）
//            ・SlideMoved    SLIDEBARのつまみが変化した（ドラッグ中）
//            ・SlideReleased SLIDEBARのつまみが離された（ドラッグ終了）
//            ・Timer         指定した時間が経過した
void _APPNAME_Dialog_DIALOGNAME_::OnTouch( PGClientSocket *pgsock, PGJsonObject *jobj ,const SGString actiontype )
{
	// 端末が CONDITION コマンドを受信するきっかけになったオブジェクトを知ることができます。
	// 押されたボタンに対する処理などを行って下さい。
	// トリガオブジェクトの名前は jobj->GetValue("Name") で取得できます。
	// リソースを変更する場合は GetResourceShare() で共有のリソースが取得できます。
	// リソースを変更した場合は、全端末へUPDATEを送信する為に SendUpdateShare(); を実行して下さい。

	// タッチされたオブジェクト名を取得
	SGString name = jobj->GetValue("Name").GetString();
	cout << "OnTouch = Name:" << name << " ,Action:" << (const char*)actiontype << endl;

	// name をチェックして、トリガオブジェクトに対する処理を行う

	// 同じダイアログを開いている自分を含む全端末にUPDATEを送信
	// 更新が行われたオブジェクトの更新が行われた要素だけを送信します。
	SendUpdateShare();
}


//--------------------------------------------------------------------------------------
// タイマー通知
// SetTimerInterval(間隔ms,ID);を実行した際に、時間が経過したことを通知する関数
// time  タイマ発生時刻
// id    登録時にセットしたID
void _APPNAME_Dialog_DIALOGNAME_::OnTimer(TimeVal time,unsigned int id)
{
  debugs;
}

//--------------------------------------------------------------------------------------
// 終了通知
void _APPNAME_Dialog_DIALOGNAME_::OnFinal()
{
	debugs;
	// このダイアログを見ている全てのセッションがなくなったときに呼ばれます
}




//--------------------------------------------------------------------------------------
// ダイアログ上のオブジェクト状態を実デバイスに反映する
void _APPNAME_Dialog_DIALOGNAME_::ResourceToDevice()
{
}
